{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "awk",
            "doc": "AWK command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:18.04",
                    "id": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Awk separator",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-F"
                    },
                    "id": "#awk.cwl/F"
                },
                {
                    "type": "File",
                    "doc": "Input file",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#awk.cwl/file"
                },
                {
                    "type": "string",
                    "doc": "Out put file name",
                    "id": "#awk.cwl/outFileName"
                },
                {
                    "type": "string",
                    "doc": "Awk text",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#awk.cwl/text"
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "awk"
            ],
            "id": "#awk.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#awk.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "grep",
            "doc": "GREP command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#grep.cwl/file"
                },
                {
                    "type": "string",
                    "id": "#grep.cwl/outFileName"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#grep.cwl/pattern"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-v"
                    },
                    "id": "#grep.cwl/v"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#grep.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "grep"
            ],
            "id": "#grep.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "doc": "SORT command",
            "label": "sort",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:18.04"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#sort.cwl/file",
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    }
                },
                {
                    "id": "#sort.cwl/k",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-k"
                    }
                },
                {
                    "id": "#sort.cwl/outFileName",
                    "type": "string"
                },
                {
                    "id": "#sort.cwl/u",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-u"
                    }
                },
                {
                    "id": "#sort.cwl/n",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-n"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#sort.cwl/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "sort"
            ],
            "id": "#sort.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "uniq",
            "doc": "UNIQ command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-c"
                    },
                    "id": "#uniq.cwl/c"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#uniq.cwl/file"
                },
                {
                    "type": "string",
                    "id": "#uniq.cwl/outFileName"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#uniq.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "uniq"
            ],
            "id": "#uniq.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "bedtools-bamtobed",
            "doc": "The bedtools utilities are a swiss-army knife of tools for a wide-range of genomics analysis tasks",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/bedtools:2.28.0--hdf88d34_0",
                    "id": "#bedtools-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "bedtools",
                            "version": [
                                "2.29.2"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/bedtools"
                            ]
                        }
                    ],
                    "id": "#bedtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-bed12"
                    },
                    "doc": "Write \u201cblocked\u201d BED (a.k.a. BED12) format. This will convert \u201cspliced\u201d BAM alignments\n(denoted by the \u201cN\u201d CIGAR operation) to BED12. Forces -split.\n",
                    "id": "#bedtools-bamtobed.cwl/bed12"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-bedpe"
                    },
                    "doc": "Write BAM alignments in BEDPE format. Only one alignment from paired-end reads will be reported.\nSpecifically, it each mate is aligned to the same chromosome, the BAM alignment reported will\nbe the one where the BAM insert size is greater than zero. When the mate alignments are\ninterchromosomal, the lexicographically lower chromosome will be reported first. Lastly,\nwhen an end is unmapped, the chromosome and strand will be set to \u201c.\u201d and the start and\nend coordinates will be set to -1. By default, this is disabled and the output will be\nreported in BED format.\n",
                    "id": "#bedtools-bamtobed.cwl/bedpe"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-i"
                    },
                    "doc": "Input BAM format",
                    "id": "#bedtools-bamtobed.cwl/i"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-mate1"
                    },
                    "doc": "When writing BEDPE (-bedpe) format, always report mate one as the first BEDPE \u201cblock\u201d.\n",
                    "id": "#bedtools-bamtobed.cwl/mate1"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-split"
                    },
                    "doc": "Report each portion of a \u201csplit\u201d BAM (i.e., having an \u201cN\u201d CIGAR operation) alignment as\na distinct BED intervals.\n",
                    "id": "#bedtools-bamtobed.cwl/split"
                },
                {
                    "type": "string",
                    "doc": "Stdout from program",
                    "id": "#bedtools-bamtobed.cwl/stdout"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.stdout)"
                    },
                    "id": "#bedtools-bamtobed.cwl/out_stdout"
                }
            ],
            "stdout": "$(inputs.stdout)",
            "baseCommand": [
                "bedtools",
                "bamtobed"
            ],
            "id": "#bedtools-bamtobed.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "label": "Compute library complexity",
            "doc": "This workflow compute library complexity",
            "inputs": [
                {
                    "type": "File",
                    "doc": "BAM file to be analyzed",
                    "id": "#main/bam_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/count_awk/output",
                    "id": "#main/out"
                }
            ],
            "steps": [
                {
                    "run": "#bedtools-bamtobed.cwl",
                    "in": [
                        {
                            "source": "#main/bam_file",
                            "id": "#main/bamtobed/i"
                        },
                        {
                            "valueFrom": "${ return inputs.i.nameroot + \".bed\";}",
                            "id": "#main/bamtobed/stdout"
                        }
                    ],
                    "out": [
                        "#main/bamtobed/out_stdout"
                    ],
                    "id": "#main/bamtobed"
                },
                {
                    "run": "#awk.cwl",
                    "in": [
                        {
                            "source": "#main/uniq/output",
                            "id": "#main/count_awk/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".pbc.qc\";}",
                            "id": "#main/count_awk/outFileName"
                        },
                        {
                            "default": "BEGIN{mt=0;m0=0;m1=0;m2=0} ($1==1){m1=m1+1} ($1==2){m2=m2+1} {m0=m0+1} {mt=mt+$1} END{printf \"%d\\t%d\\t%d\\t%d\\t%f\\t%f\\t%f\\n\",mt,m0,m1,m2,m0/mt,m1/m0,m1/m2}",
                            "id": "#main/count_awk/text"
                        }
                    ],
                    "out": [
                        "#main/count_awk/output"
                    ],
                    "id": "#main/count_awk"
                },
                {
                    "run": "#grep.cwl",
                    "in": [
                        {
                            "source": "#main/first_awk/output",
                            "id": "#main/filter_chrM/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".grep\";}",
                            "id": "#main/filter_chrM/outFileName"
                        },
                        {
                            "default": "chrM",
                            "id": "#main/filter_chrM/pattern"
                        },
                        {
                            "default": true,
                            "id": "#main/filter_chrM/v"
                        }
                    ],
                    "out": [
                        "#main/filter_chrM/output"
                    ],
                    "id": "#main/filter_chrM"
                },
                {
                    "run": "#awk.cwl",
                    "in": [
                        {
                            "source": "#main/bamtobed/out_stdout",
                            "id": "#main/first_awk/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".awk\";}",
                            "id": "#main/first_awk/outFileName"
                        },
                        {
                            "default": "BEGIN{OFS=\"\\t\"}{print $1,$2,$3,$6}",
                            "id": "#main/first_awk/text"
                        }
                    ],
                    "out": [
                        "#main/first_awk/output"
                    ],
                    "id": "#main/first_awk"
                },
                {
                    "run": "#sort.cwl",
                    "in": [
                        {
                            "source": "#main/filter_chrM/output",
                            "id": "#main/sort/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".sort\";}",
                            "id": "#main/sort/outFileName"
                        }
                    ],
                    "out": [
                        "#main/sort/output"
                    ],
                    "id": "#main/sort"
                },
                {
                    "run": "#uniq.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/uniq/c"
                        },
                        {
                            "source": "#main/sort/output",
                            "id": "#main/uniq/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".uniq\";}",
                            "id": "#main/uniq/outFileName"
                        }
                    ],
                    "out": [
                        "#main/uniq/output"
                    ],
                    "id": "#main/uniq"
                }
            ],
            "id": "#main",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "https://schema.org/version/latest/schemaorg-current-http.rdf"
    ],
    "$namespaces": {
        "s": "http://schema.org/"
    }
}
